/*
 * Actor.java
 *
 * Created on March 31, 2003, 6:05 PM
 */

package actor;

import geometry.*;
import java.awt.Graphics;
import javax.swing.JPanel;
/**
 *
 * @author  rod
 */
public abstract class Actor{
    protected Point location;
    public String name;
    
    /** Creates a new instance of Actor */
    public Actor(Point loc){
        location = loc;
    }
    
    public Point position(){
        return location;
    }
    
    public void setPosition(Point p){
        location = p;
    }
    
    public void setName(String n){
        name = n;
    }
    
    public String name(){
        return name;
    }

    public abstract boolean canBeGoal();
    
    public String toString(){
        return name;
    }
    
    public abstract int type();
    
    public abstract void draw(Graphics g);
    
    public abstract String description();
    
    public abstract void showControl();
    
    public abstract JPanel controlPanel();
    
    abstract public void resize(Point start, Point end);
}
