/*
 * Goal.java
 *
 * Created on March 31, 2003, 6:06 PM
 */

package actor;

import java.awt.Color;
import java.awt.Graphics;
import geometry.*;
import javax.swing.*;
import java.awt.Container;
import javax.swing.event.*;
import java.awt.event.*;

/**
 *
 * @author  rod
 */
public class Goal extends Actor implements GoalStackable, ChangeListener, ActionListener{
    Color color;
    double radius;
    static int goalNum=0;
    
    /** Creates a new instance of Goal */
    public Goal(Color c, double rad, Point loc) {
        super(loc);
        color = c;
        radius = rad;
        setName("Goal " + (++goalNum));
    }
    
    public boolean canBeGoal(){
        return true;
    }
    
    public void draw(Graphics g) {
        if (g == null) return;
        int ulx = Universe.u2sx(position());
        int uly = Universe.u2sy(position());
        int r = Universe.u2s(radius);
        Color pc = g.getColor();
        g.setColor(color);
        g.fillOval(ulx - r, uly - r, 2*r, 2*r);
        g.setColor(pc);
    }
    
    public double radius(){
        return radius;
    }
    
    public void resize(Point start, Point end){
        double d = end.distanceTo(start);
        radius = d;
    }

    public int type() {
        return Type.GOAL;
    }
    
    /* #################################################### */
    
    public void showControl(){
        if (!ActorControlFrame.open.contains(this))
            new ActorControlFrame(this);
    }
    
    public String description(){
        String out;
        out = "Name: " + name() + "\n";
        out += "Type: Goal\n";
        out += "Location: "+position().toString();
        return out;
    }
    
    private JColorChooser cc;
    private JTextField nameField;
    
    public JPanel controlPanel() {
        //colour, radius, name, location
        JPanel p = new JPanel();
        cc = new JColorChooser(Color.red);
        //cc.setPreviewPanel(new JPanel());
        cc.getSelectionModel().addChangeListener(this);
        p.add(cc);
        JLabel nameLabel = new JLabel("Name: ");
        JTextField nameField = new JTextField(name(), 15);
        nameField.addActionListener(this);
        JPanel namePanel = new JPanel();
        namePanel.add(nameLabel);
        namePanel.add(nameField);
        cc.setPreviewPanel(namePanel);
        return p;
    }
    
    
    public void actionPerformed(java.awt.event.ActionEvent ae){
        if (ae.getSource().equals(nameField)){
            name = nameField.getText();
            nameField.setText(name);
        }
    }
    
    public void stateChanged(javax.swing.event.ChangeEvent e) {
        color = cc.getColor();
    }
    
    
    /* #################################################### */
}
