/*
 * Square.java
 *
 * Created on April 16, 2003, 6:36 PM
 */

package actor;
import geometry.Point;
import java.awt.Color;
import java.util.Vector;
import java.awt.event.*;
import javax.swing.event.*;
import javax.swing.*;

/**
 *
 * @author  rod
 */
public class Triangle extends Obstacle implements ChangeListener, ActionListener{
    double side;
    static final double r36 = Math.sqrt(3.0)/6;
    
    /** Creates a new instance of Triangle */
    public Triangle(Point location, Color c) {
        super(location, new Vector(), c);
        setSideLength(1.0);
    }
    
    public void resize(Point start, Point end){
        double d = end.distanceTo(start);
        side = d;
        setSideLength(side);
    }
    
    public void setSideLength(double s){
        border=new Vector();
        double x = position().xValue();
        double y = position().yValue();
        border.addElement(new Point(x-.5*s,y-r36*s));
        border.addElement(new Point(x,y+2*r36*s));
        border.addElement(new Point(x+.5*s,y-r36*s));
        side = s;
        setLocation (position());
    }
    
    public boolean canBeGoal(){
        return false;
    }
    
        /* #################################################### */
    
    public void showControl(){
        if (!ActorControlFrame.open.contains(this))
            new ActorControlFrame(this);
    }
    
    public String description(){
        String out;
        out = "Name: " + name() + "\n";
        out += "Type: Obstacle/Triangle\n";
        out += "Location: "+position().toString();
        return out;
    }
    
    private JColorChooser cc;
    private JTextField nameField;
    private JTextField sideLengthField;
    
    public JPanel controlPanel() {
        JPanel p = new JPanel();
        cc = new JColorChooser(Color.red);
        //cc.setPreviewPanel(new JPanel());
        cc.getSelectionModel().addChangeListener(this);
        p.add(cc);
        JLabel nameLabel = new JLabel("Name: ");
        nameField = new JTextField(name(), 15);
        nameField.addActionListener(this);
        JLabel sideLengthLabel = null;
        sideLengthLabel = new JLabel("Side length: ");
        sideLengthField = new JTextField(""+side, 15);
        sideLengthField.addActionListener(this);
        JPanel namePanel = new JPanel();
        namePanel.add(nameLabel);
        namePanel.add(nameField);
        namePanel.add(sideLengthLabel);
        namePanel.add(sideLengthField);
        cc.setPreviewPanel(namePanel);
        return p;
    }
    
    public void actionPerformed(java.awt.event.ActionEvent ae){
        if (ae.getSource().equals(nameField)){
            name = nameField.getText();
            nameField.setText(name);
        }
        if (ae.getSource().equals(sideLengthField)){
            side = (new Double((sideLengthField.getText()))).doubleValue();
            sideLengthField.setText(""+side);
            setSideLength(side);
        }
    }
    
    public void stateChanged(javax.swing.event.ChangeEvent e) {
        color = cc.getColor();
    }
}
