/*
 * Point.java
 *
 * Created on March 31, 2003, 6:08 PM
 */

package geometry;

import java.awt.Graphics;
import java.awt.Color;
import actor.Universe;
/**
 *
 * @author  rod
 */
public class Point {
    protected double x;
    protected double y;
    
    /** Creates a new instance of Point */
    public Point() {
        x = 0;
        y = 0;
    }
    public Point (double x, double y){
        this.x = x;
        this.y = y;
    }
    
    public double xValue(){
        return x;
    }

    public double yValue(){
        return y;
    }
    
    public double distanceTo(Point p){
        double dx = x - p.xValue();
        double dy = y - p.yValue();
        return Math.sqrt(dx*dx + dy*dy);
    }
    
    public double distanceTo2(Point p){
        double dx = x - p.xValue();
        double dy = y - p.yValue();
        return (dx*dx + dy*dy);
    }
    
    public Point add(Point toAdd){
        return new Point (x + toAdd.xValue(), y + toAdd.yValue());
    }

    public Point sub(Point toAdd){
        return new Point (x - toAdd.xValue(), y - toAdd.yValue());
    }

    public Point scale(double val){ //dubious use here... more for Vec
        x *= val;
        y *= val;
        return this;
    }
    
    public Point mul(double val){
        return new Point(x*val, y*val);
    }
    
    public String toString(){
        return "("+Math.round(x/1000.0)*1000.0+","+Math.round(y/1000.0)*1000.0+")";
    }
    
    public void draw(Graphics g){
        int sx = Universe.u2sx(this);
        int sy = Universe.u2sy(this);
        g.setColor(Color.black);
        g.drawLine(sx-2, sy-2, sx+2, sy+2);
        g.drawLine(sx-2, sy+2, sx+2, sy-2);
    }
}
